unit iniparser;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,IniFiles,fppkutils;
var Ini:TIniFile;
    StrictPaths,IgnoreCase:boolean;
    Libs:TStringList;
    FPC:string;
function InLib(const FName:string):string;

implementation

const IniFNM='fppkg.ini';
var IniFName:string;

function InLib(const FName: string): string;
var
  i, j: Integer;
  FNm, s, s1: String;
  List: TStringList;
begin
  Result:='';
  for i:=0 to Libs.Count-1 do
  begin
    Libs.NameValueSeparator:='=';
    FNm:=Trim(Libs.ValueFromIndex[i]);
    if not FileExists(FNm) then begin
       writeln(StdErr,'Error in ini file: pkg ',Libs.Names[i],' has wrong file ',Fnm);
       Continue;
    end;
    List:=TStringList.Create;
    List.LoadFromFile(Fnm);
    for j:=1 to List.Count-1 do
    begin
      s:=Trim(List[j]);
      if s<>'' then if s[Length(s)]='\' then s:=trim(copy(s,1,Length(s)-1));
      if SCmp(s,'-l') then continue ;
      if not StrictPaths then begin s:=ExtractFileName(s);s1:=ExtractFileName(FName);end
       else s1:=FName;
      if IgnoreCase then begin S:=AnsiLowerCase(S);s1:=AnsiLowerCase(S1);end;
      if s1=s then begin Result:=Libs.Names[i];List.Free;
         exit; end;
    end;
    List.Free;
  end;
end;

initialization
  {$ifdef unix}
  IniFName:=PSep(GetEnvironmentVariable('HOME'))+'.'+IniFNM;
  if not FileExists(IniFName) then begin
     IniFName:='/etc/'+IniFNM;
  end;
  {$else}{$ifdef MSWindows}
    IniFName:=PSep(GetEnvironmentVariable('HOME'))+'.'+IniFNM;
  {$endif}
  {$endif}
  if not FileExists(IniFName) then begin
     IniFName:=PSep(ExtractFilePath(ParamStr(0)))+IniFNM;
     if not FileExists(IniFName) then begin
        Writeln(StdErr,'Error: ',IniFNM,' is not found. No way to process with libraries');
        halt;
     end;
  end;
  Ini:=TIniFile.Create(IniFName);
  StrictPaths:=Ini.ReadInteger('Settings','StrictPaths',0)<>0;
  Writeln('Strict', StrictPaths);
  FPC:=Ini.ReadString('Settings','FPC','fpc');
  IgnoreCase:=Ini.ReadInteger('Settings','IgnoreCase',{$ifdef unix}0{$else}1{$endif})<>0;
  Libs:=TStringList.Create;
  Ini.ReadSectionRaw('Libs',Libs);
finalization
  Ini.Free;
  Libs.Free;
end.

